package services.pescado.fusionservice;

import java.util.logging.Level;
import java.util.logging.Logger;

import javax.xml.ws.Endpoint;

import services.pescado.fusionservice.impl.FusionServiceImpl;


/**
 * Startup the dummy service. Give the servername and port as the first
 * argument.
 * 
 * @author J&uuml;rgen Mo&szlig;graber (Fraunhofer IOSB),
 * @author Lasse Johansson (FMI)
 */
public final class Startup
{
	private final static Logger	LOGGER	= Logger.getLogger ("FS");


	/**
	 * Starts the SOAP service.
	 * 
	 * @param args Index 0 must contain the server and port on which to start the
	 *          service.
	 */
	public static void main (final String [] args)
	{
		if (args.length != 1)
		{
			LOGGER.info ("Please give the server and port as parameter, e.g. 'mymachine:4711'. Exiting.");
			return;
		}

		try
		{
			final String url = "http://" + args[0] + "/fs";
			LOGGER.info ("Fusion Service listening on: " + url);

			// String dateTest = "2011-12-29T00:00:00-02:00";
			// Datetime dt = new Datetime(dateTest);
			// // System.out.println(dt.getStringDate() + "\t" + dt.hourCounter);
			//
			// String dateTest2 = "2011-12-29T04:00:00+02:00";
			// Datetime dt2 = new Datetime(dateTest2);
			// // System.out.println(dt2.getStringDate() + "\t" + dt2.hourCounter);
			//
			// // create mapPack and DB
			// java.io.File file = new java.io.File(""); // Dummy file
			// String abspath = file.getAbsolutePath();
			// String Z = System.getProperty("file.separator");
			// System.out.println("mapPack initalization...");
			// MapPack maps = new MapPack("Finland", abspath + Z);
			// DataBase DB = new DataBase(abspath + Z);
			//
			// // mapPack test==========
			// double lat = 60.16803; // center of Helsinki
			// double lon = 24.941098;
			//
			// String exProfile = maps.getExtenedProfile(lat, lon, 400);
			// // int pop = maps.getLocalPopulation(lat, lon);
			//
			// System.out.println("extended Profile test with lat=" + lat
			// + " lon =" + lon + "\t" + exProfile);
			// System.out.println("Local population:");
			// for (int i = 0; i < 10; i++) {
			// double area = 2.0 * i + 1;
			// int pop2 = maps.getLocalPopulation(lat, lon, area);
			// System.out.println(pop2 + "\t" + area + " km2");
			// }

			// final FusionServiceImpl service = new FusionServiceImpl(maps, DB);
			final FusionServiceImpl service = new FusionServiceImpl ();

			

			Endpoint.publish (url, service);
		}
		catch (final Throwable t)
		{
			LOGGER.log (Level.SEVERE, t.getLocalizedMessage (), t);
		}
	}


	/**
	 * Private cause it is a helper class.
	 */
	private Startup ()
	{
		// Empty by intention
	}
}
