/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package services.pescado.fusionservice.impl.Masks;

//import java.awt.BorderLayout;
//import java.awt.Image;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

import java.io.Serializable;
import javax.imageio.ImageIO;
//import javax.swing.ImageIcon;
//import javax.swing.JFrame;
//import javax.swing.JLabel;



/**
 *
 * @author johanssl
 */
public class DensityMask implements Serializable{
 
        String name;
        //BufferedImage img;
        int width;
        int height;
        int[] density;
        double lonmin;
	double lonmax;
	double latmin;
	double latmax;
        double mapSize;
	boolean mask_available;
	String rootdir;
        public final double pi = Math.PI;
        public final double degreeInMeters = 2*pi*6371000/360;
		//Constructors
        
               public DensityMask(String[] mapSpecs, String rootdir) throws IOException {
          
		this.name = mapSpecs[0];
		BufferedImage img = null;
		int w=-1, h=-1; 
		int pixels[];
		
		 String Z = System.getProperty("file.separator");
		 this.lonmin = Double.valueOf(mapSpecs[1]);
		 this.lonmax = Double.valueOf(mapSpecs[2]);
		 this.latmin = Double.valueOf(mapSpecs[3]);
		 this.latmax = Double.valueOf(mapSpecs[4]);
		
		 int red,green,blue;
		 // MAP NAME AND DIRECTORY
			String file = rootdir+"maps"+Z+this.name;
		    
			 img = ImageIO.read(new File(file));
			 this.mask_available= true;
			 //this.img = img;
			 w = img.getWidth();
			 h = img.getHeight();
			 this.width = w;
			 this.height = h;
                         double midlat = (this.latmin + this.latmax)/2.0;
                         final double scaler = Math.cos((2*Math.PI)/360*midlat);
                         //mapSize
                         this.mapSize = (this.latmax-this.latmin)*(this.lonmax-this.lonmin)*scaler;
		    
                 


			 pixels = new int[w * h];
			 img.getRGB(0, 0, w, h, pixels, 0, w);
			// System.out.println(img.getWidth() + " X " + img.getHeight());
			 

		         this.density = new int[pixels.length];
					 for (int k = 0;k < pixels.length;k++) {
					 red = ((pixels[k] >> 16) & 0xff);
					 green = ((pixels[k] >> 8) & 0xff);
					 blue = (pixels[k] & 0xff);
                                            int[] temp = {red,green,blue};
                                         
                                         int dens = this.evaluateDensity(temp);
                                         this.density[k] = dens;
					 //System.out.println("index: " +index);
					
					 }
   
        }
        
        

	
	public void print_map_attributes() {
		System.out.println(this.name+":" );
		System.out.println("Map width: "+this.width+" height: "+this.height +" Pixels: "+this.width*this.height);
		System.out.println("Coordinate limits, latitude: " +this.latmin + " - "+this.latmax);
		System.out.println("Coordinate limits, longitude: " +this.lonmin + " - "+this.lonmax);
	}
	
	


	public  int calc_index(double latitude,double longitude) {
		int index=0;
		
		//upper left corner is the [0]
		double lat_diff = this.latmax-latitude;
		double lon_diff = longitude - this.lonmin;
		double dlat = (this.latmax - this.latmin)/this.height;
		double dlon = (this.lonmax - this.lonmin)/this.width;
		
		int n_lats = (int)(lat_diff/dlat);
		int n_lons = (int)(lon_diff/dlon);
		
		index = (n_lats)*this.width + n_lons;
		
		//System.out.println("index calc: (latitude,longitude,nlat,nlon,index"+latitude+" "+longitude+" "+n_lats+" "+n_lons+" "+index);
		
		return index;
	}

/* This method returns the population density for any given coordinates. If the coorinates are out of bounds then color value is returned 0,0,0 which will result in zero density
if mask is not available, then density is not checked
*/
	public int getDensity(double lat,double lon) {
		
                if(this.containsCoordinates(lat, lon)) {
		int index = this.calc_index(lat, lon);
                try { return this.density[index];
        } catch (ArrayIndexOutOfBoundsException e) {
            System.err.println(this.name+ ": "+lat+", "+lon + ",bounds :"+this.latmin +","+this.latmax+", "+ this.lonmin + ", "+this.lonmax);
            
            return 0;
        }
	} else {
        return 0;
	}

	}

	
	public int evaluateDensity(int[] rgb) {
	    final int scaler = 16; //the density image corresponds to the number of residents in a 250m x 250m area => 16x to obtain per km2	
            int density =0;

		/*Population density maps as a function of RGB, provided by Tietohallinto service FMI (2010 data)
		 */ 
                 if (rgb[0] == 10 && rgb[1] == 100 && rgb[2] == 255 ) {    
                    density = 2100*scaler;	
                }
                 else if (rgb[0] == 200 && rgb[1] == 0 && rgb[2] == 255 ) {    
                    density = 1875*scaler;
                 }
                  else if (rgb[0] == 50 && rgb[1] == 170 && rgb[2] == 100 ) {    
                    density = 1625*scaler;
                 }
                 else if (rgb[0] == 50 && rgb[1] == 100 && rgb[2] == 255 ) {    
                    density = 1375*scaler;
                 }
                else if (rgb[0] == 255 && rgb[1] == 0 && rgb[2] == 255 ) {    
                    density = 1125*scaler;			
		} //254 0 0
		else if (rgb[0] == 70 && rgb[1] == 100 &&rgb[2] == 20) {	    
                    density = 875*scaler;		
                }
                else if (rgb[0] == 255 && rgb[1] == 251 &&rgb[2] == 240) {	    
                    density = 625*scaler;		
                }
		else if (rgb[0] == 0 && rgb[1] == 128 &&rgb[2] == 128) {
                    density = 450*scaler;    
		}//245 254 167
		else if (  rgb[0] == 0 && rgb[1] == 255 &&rgb[2] == 255  ) {
			density = 350*scaler;	
		}    
		else if ( ( rgb[0] == 32 && rgb[1] == 32 &&rgb[2] == 128 ) ) {
			density = 250*scaler;	
		}
		else if ( (rgb[0] == 0 && rgb[1] == 32 &&rgb[2] == 128) ) {
			density = 175*scaler;	
		}
		else if (rgb[0] == 0 && rgb[1] == 0 && rgb[2] == 255) {
			density = 125*scaler;
			
		}
		else if (rgb[0] == 166 && rgb[1] == 202 &&rgb[2] == 240) {
			density = 95*scaler;	
		}
		else if (rgb[0] == 0 && rgb[1] == 96 &&rgb[2] ==  0) {
			density = 85*scaler;	
		}
		else if (rgb[0] == 0 && rgb[1] == 255 &&rgb[2] == 0) {
			density = 75*scaler;
		} else if (rgb[0] == 192 && rgb[1] == 220 &&rgb[2] ==  192) {
			density = 65*scaler;
		} else if (rgb[0] == 128 && rgb[1] == 0 &&rgb[2] ==  0) {
			density = 55*scaler;
		} else if (rgb[0] == 255 && rgb[1] == 0 &&rgb[2] ==  0) {
			density = 45*scaler;
		} else if (rgb[0] == 224 && rgb[1] ==160 &&rgb[2] ==  192) {
			density = 35*scaler;
                } else if (rgb[0] == 0 && rgb[1] ==0 &&rgb[2] ==  0) {
			density = 25*scaler;
                } else if (rgb[0] == 128 && rgb[1] ==128 &&rgb[2] ==  128) {
                density = 15*scaler;
                } else if (rgb[0] == 160 && rgb[1] ==160 &&rgb[2] ==  164) {
                density = 8*scaler;
                } else if (rgb[0] == 255 && rgb[1] ==255 &&rgb[2] ==  0) {
                density = 3*scaler;
                }else if (rgb[0] == 255 && rgb[1] ==255 &&rgb[2] ==  255) {
                density = 0;
		} else {
                    density =0*scaler;
                   
                    //System.out.println("Unspecified color: "+rgb[0]+" " + rgb[1] +" "+ rgb[2]);
                }

		
		return density;
	}


   

 	public void showDensitymap() {
            /*
	JFrame frame = new JFrame();
	
	int scaled_height = 500;
	int scaled_width = (int)(this.width/this.height*scaled_height);
	
	int i = this.img.SCALE_SMOOTH;
    Image img2 = this.img.getScaledInstance(scaled_width,scaled_height, i);
	
	JLabel label = new JLabel(new ImageIcon(img2));
	frame.getContentPane().add(label, BorderLayout.CENTER);
	frame.pack();
	frame.setVisible(true);
             * 
             */
}
//get local population in area = 3km2. Resolution determines the area, which is 250m * (2*res +1) x 250m *(2*res+1)
        //e.g. if res = 4 then area is about 5km2 and 81 pixels are evaluated
public int getLocalPopulation(double lat, double lon, int res) {
  int population = 0;

 double dlat = (this.latmax-this.latmin)/this.height;
 double dlon = (this.lonmax-this.lonmin)/this.width;
 double lonScaler = Math.cos(2*pi*lat/360);
 

int iMax = res;
int jMax = res; 
final int scaler = 16;
int counter =0;

for (int i = -iMax;i<=iMax;i++) {
    
    double latitude = lat + i*dlat;
    
        for (int j =-jMax;j<=jMax;j++) {
        double longitude = lon + j*dlon;    
          try {
            population = population + this.getDensity(latitude, longitude)/scaler;
            counter++;
            //System.out.println("Population in km2: "+population+" number of pixels "+counter);
            } catch (Exception e) {
               System.out.println("Could not retrieve population dens!"); 
            }   
        }
     
    
}
double area = (double)(counter)/(double)(scaler);
  //System.out.println("Population in "+area+ "km2: "+population+" number of pixels "+counter);


  return population;
}

	public boolean containsCoordinates(double lat1,double lon1) {
            
            if(lat1 > this.latmax || lat1 < this.latmin || lon1 > this.lonmax || lon1 < this.lonmin ) {
             //   console.out("point 1 is not covered. (lat, lon) " +lat1 +", "+lon1);
                return false;
                
                    } else {           
                    return true;
                    } 
        }

}
