package services.pescado.fusionservice.impl.Masks;

public class Env {
	public double pop;
    public double traf;
    public double vege;
    public double urban;
    public double econoInd;
    public double sub;
    public double water;
    public double neutral;
    public double ecoUrb;
    
    
    public String exProfile;
    public int n;
    public boolean predef = false;
    public boolean override = false;
    
    public Env(double[] suit) {
        
        if (suit == null) {
         this.sub = 0;
        this.urban = 0;
        this.econoInd = 0;
        this.traf = 0;
        
        this.pop = 0;
        this.vege = 0.8;
        this.water = 0;
        this.n =0;
         
        
        } else {
        this.pop = suit[0];
        this.sub = suit[1];
        this.urban = suit[2];
        this.econoInd = suit[3];
        this.traf = suit[4];        
        this.vege = suit[5];
        this.water = suit[6];
        this.n = (int)suit[7];
        

        }
        this.neutral = vege + water;
        this.ecoUrb = econoInd + urban;
        this.exProfile = this.evaluateProfile();
    }
    
        //String constructor... note that anything not listed here will result in Override environment (no average correction)   
        public Env(String predef) {
        this.predef = true;
        if (predef.equals("vb")) {
         
        this.pop = 0;
        this.sub = 0;
        this.urban = 0;
        this.econoInd = 0;
        this.traf = 0;        
        this.vege = 0.8;
        this.water = 0;
        this.n = 0;
        this.exProfile = "vb";
        

        } else if (predef.equals("Ht")) {
        this.pop = 80;
        this.sub = 0;
        this.urban = 0.3;
        this.econoInd = 0.3;
        this.traf = 0.2;        
        this.vege = 0;
        this.water = 0;
        this.n = 0;
        this.exProfile = "Ht";
        } 
        else if (predef.equals("mb")) {
        this.pop = 40;
        this.sub = 0.4;
        this.urban = 0.1;
        this.econoInd = 0;
        this.traf = 0;        
        this.vege = 0.4;
        this.water = 0;
        this.n = 0;
        this.exProfile = "mb";
        } 
        
        else if (predef.equals("lb")) {
            this.pop = 20;
            this.sub = 0.2;
            this.urban = 0;
            this.econoInd = 0;
            this.traf = 0;        
            this.vege = 0.8;
            this.water = 0;
            this.n = 0;
            this.exProfile = "lb";
            } 
        
        else if (predef.equals("ht")) {
        this.pop = 50;
        this.sub = 0;
        this.urban = 0.4;
        this.econoInd = 0.2;
        this.traf = 0.15;        
        this.vege = 0;
        this.water = 0;
        this.n = 0;
        this.exProfile = "ht";
        } else {
        
        //System.out.println("Env: not known -"+predef + ", Override");
        this.pop = 0;
        this.sub = 0;
        this.urban = 0;
        this.econoInd = 0;
        this.traf = 0;        
        this.vege = 0.80;
        this.water = 0;
        this.n = 0;
        this.override = true;
        this.exProfile = "or";
        }
        
        this.neutral = vege + water;
        this.ecoUrb = econoInd + urban;
        
    }
    
    
    
    
    private String evaluateProfile() {
       if (n==0) {
           return "or";
       } else {
        
            String prof;

            if ((urban + econoInd)/5 + traf > 0.25) {
            prof ="T"; 
            } else if ((urban + econoInd)/5 + traf > 0.12) {
            prof ="t";

            } else {
            prof ="b";  
            }


            String dp; 
            if (pop > 60) {
            dp = "H";
            } else if (pop > 40) {
            dp = "h";
            } else if (pop > 20) {
            dp = "m";
            } else  {
            dp = "l";
            } 


            String exProfile = dp+prof;

            //special changes
            if (exProfile.equals("lT")) exProfile = "lt";
            if (exProfile.equals("lb") && pop <2) exProfile = "vb";
           
           return exProfile;
       }
       
        
    }
    
    
    public String getSummary() {
        String n = System.getProperty("line.separator");
        String o ="";
        o = o+"Short profile: "+this.exProfile + n;
        o = o + "Pixels evaluated: " + this.n +n;
        o = o + "neutral: " + (int)(this.neutral*100) + "%"+n;
        o = o + "traffic: " + (int)(this.traf*100) + "%"+n;
        o = o + "population: " + this.pop*1000 +n;
        o = o + "urban: " + (int)(this.urban*100) + "%"+n;
         o = o + "econoInd: " + (int)(this.econoInd*100) + "%"+n;
         
         return o;
    }
}
