/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package services.pescado.fusionservice.impl.Masks;

/**
 *
 * @author johanssl
 */


//import java.awt.BorderLayout;
//import java.awt.Color;
//import java.awt.Image;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

import java.io.Serializable;
import javax.imageio.ImageIO;
//import javax.swing.ImageIcon;
//import javax.swing.JFrame;
//import javax.swing.JLabel;


public class LandMask implements Serializable{
	String name;
	//BufferedImage img;
	int width;
        int height;
        double dlon;
        double dlat;
        double dlatInMeters;
        double dlonInMeters;
        double maxEvalRadius;
        
        
        private char[] charMask;
	double lonmin;
	double lonmax;
	double latmin;
	double latmax;
        double mapSize;
	public boolean mask_available;
	String rootdir;
        public final double pi = Math.PI;
        public final double degreeInMeters = 2*pi*6371000/360;
        public String[][] maps; 
		//Constructors
        
        
        
        public LandMask(String[] mapSpecs, String rootdir) throws IOException {
  
		this.name = mapSpecs[0];
		BufferedImage img = null;
		int w=-1, h=-1; 
		int pixels[];
		
		 String Z = System.getProperty("file.separator");
		 this.lonmin = Double.valueOf(mapSpecs[1]);
		 this.lonmax = Double.valueOf(mapSpecs[2]);
		 this.latmin = Double.valueOf(mapSpecs[3]);
		 this.latmax = Double.valueOf(mapSpecs[4]);
		
		 int red,green,blue;
		 // MAP NAME AND DIRECTORY
			String file = rootdir+"maps"+Z+this.name;
		    
			 img = ImageIO.read(new File(file));
			 this.mask_available= true;
			 //this.img = img;
			 w = img.getWidth();
			 h = img.getHeight();
			 this.width = w;
			 this.height = h;
                         double midlat = (this.latmin + this.latmax)/2.0;
                         final double scaler = Math.cos((2*Math.PI)/360*midlat);
                         //mapSize
                         this.mapSize = (this.latmax-this.latmin)*(this.lonmax-this.lonmin)*scaler;
                         
                          this.dlat = (this.latmax-this.latmin)/this.height;
                          this.dlon = (this.lonmax-this.lonmin)/this.width;
                         double lonScaler = Math.cos(2*pi*(latmax-latmin)/360);
                         this.dlatInMeters = dlat*this.degreeInMeters;
                         this.dlonInMeters = dlon*this.degreeInMeters*lonScaler;
		         this.maxEvalRadius = Math.max(dlatInMeters, dlonInMeters)*8; 
              


			 pixels = new int[w * h];
			 img.getRGB(0, 0, w, h, pixels, 0, w);
			// System.out.println(img.getWidth() + " X " + img.getHeight());
			 

		         this.charMask = new char[pixels.length];
					 for (int k = 0;k < pixels.length;k++) {
					 red = ((pixels[k] >> 16) & 0xff);
					 green = ((pixels[k] >> 8) & 0xff);
					 blue = (pixels[k] & 0xff);
                                            int[] temp = {red,green,blue};
                                         
                                         char type = this.evaluateLandChar(temp);
                                         this.charMask[k] = type;
					 //System.out.println("index: " +index);
					
					 }
   
        }

	 

	public void print_map_attributes() {
		System.out.println(this.name+":" );
		System.out.println("Map width: "+this.width+" height: "+this.height +" Pixels: "+this.width*this.height);
		System.out.println("Coordinate limits, latitude: " +this.latmin + " - "+this.latmax);
		System.out.println("Coordinate limits, longitude: " +this.lonmin + " - "+this.lonmax);
	}
	
/*	
	public void show_map() {
	JFrame frame = new JFrame();
	
	int scaled_height = 1000;
	int scaled_width = (int)(this.width/this.height*scaled_height);
	
	int i = this.img.SCALE_SMOOTH;
    Image img2 = this.img.getScaledInstance(scaled_width,scaled_height, i);
	
	JLabel label = new JLabel(new ImageIcon(img2));
	frame.getContentPane().add(label, BorderLayout.CENTER);
	frame.pack();
	frame.setVisible(true);
}

         * 
         */
	public  int calc_index(double latitude,double longitude) {
		int index=0;
		
		//upper left corner is the [0]
		double lat_diff = this.latmax-latitude;
		double lon_diff = longitude - this.lonmin;
		double dlat = (this.latmax - this.latmin)/this.height;
		double dlon = (this.lonmax - this.lonmin)/this.width;
		
		int n_lats = (int)(lat_diff/dlat);
		int n_lons = (int)(lon_diff/dlon);
		
		index = (n_lats)*this.width + n_lons;
		
		//System.out.println("index calc: (latitude,longitude,nlat,nlon,index"+latitude+" "+longitude+" "+n_lats+" "+n_lons+" "+index);
		
		return index;
	}
        
public char get_maskChar(double lat,double lon) {
	char value = 'X';	
	
	if(this.containsCoordinates(lat,lon) ) {
		int index = this.calc_index(lat, lon);
	try { return this.charMask[index];
        } catch (ArrayIndexOutOfBoundsException e) {
            System.err.println(this.name+ ": "+lat+", "+lon + ",bounds :"+this.latmin +","+this.latmax+", "+ this.lonmin + ", "+this.lonmax);
            
            return value;
        }
        } else {	
	return value;
	}
}

       

        

	private char evaluateLandChar(int[] rgb) {
        char landType = 'X';
		/*land usage as a function of RGB according to Tietohallinto service FMI
		 * # value red green blue

1 229 0 76    "Dense urban"
2 254 0 0     "Loose Urban"
3 178 50 229  "Industrial"
4 203 0 0     "Traffic"
5 229 178 178 "Harbor"
6 216 190 216 "Airport"
7 167 0 206   "Mining"
8 165 76 0    "Dumpyard"
9 255 220 154  "Construction"
10 254 229 254  "Recreational"
14 245 254 167  "Farmfield"
16 241 165 0    "Fruit farming"
17 241 241 67   "Herding"
18 127 254 0    "Leafforest"
20 0 165 0      "Pineforest"
23 0 190 0      "Forest"
26 203 229 76    "Plains"
33 165 229 0       "Scarse forest"
34 220 220 220    "Beach"
35 200 200 200    "Bedrock"
36 165 165 254    "Inland wetland"
38 240 240 240    "Bog"
40 203 203 253    "coastal wetland"
41 203 203 253    "coastal wetland"
42 0 203 229      "River"
43 165 229 229    "Lake"
44 228 241 253    "Sea"
45 227 241 253    "Sea"
		 * 
		 * DUPLICATES HAVE BEEN REMOVED
		 */
		
		//229 0 76
		if (rgb[0] == 229 && rgb[1] == 0 && rgb[2] == 76 ) {
		    
                landType ='U';//urban
		} //254 0 0
		else if (rgb[0] == 254 && rgb[1] == 0 &&rgb[2] == 0) {
		    
                landType = 'S';//suburban
                }
		
		else if (rgb[0] == 203 && rgb[1] == 0 &&rgb[2] == 0) {
		
                landType = 'T';//road
		}//245 254 167
		else if (  rgb[0] == 245 && rgb[1] == 254 &&rgb[2] == 167  ) {
                landType = 'V';
		}             //leaf  vege                                        //pine
		else if ( ( rgb[0] == 127 && rgb[1] == 254 &&rgb[2] == 0 )||( rgb[0] == 0 && rgb[1] == 165 &&rgb[2] == 0 || ( rgb[0] ==0 && rgb[1] == 190 &&rgb[2] == 0 ))  ) {
                landType = 'V'; //vege
		}
		else if ( (rgb[0] == 203 && rgb[1] == 229 &&rgb[2] == 76) || (rgb[0] == 205 && rgb[1] == 205 &&rgb[2] == 102) ) {
                landType = 'V';//vege
		}
		else if (rgb[0] == 165 && rgb[1] == 229 &&rgb[2] == 0) {
                landType = 'V'; //vege
		}
		else if (rgb[0] == 240 && rgb[1] == 240 &&rgb[2] == 240) {
                landType = 'V'; //vegetation
		}
		else if (rgb[0] == 165 && rgb[1] == 229 &&rgb[2] == 229) {
                landType = 'w'; //lake
		}
		else if ((rgb[0] == 228 || rgb[0]==227) && rgb[1] == 241 &&rgb[2] == 253) {
                landType = 'W'; //SEA
		} else if (rgb[0] == 229 && rgb[1] == 178 &&rgb[2] == 178) {
                landType = 'H';//harbor
		} else if (rgb[0] == 216 && rgb[1] == 190 &&rgb[2] == 216) {
                landType = 'A';//airport
		} else if (rgb[0] == 167 && rgb[1] == 0 && rgb[2] == 206) {
                landType = 'M'; //mining
		} else if (rgb[0] == 178 && rgb[1] == 50 && rgb[2] == 229) {
                landType = 'I'; //industrial
		} else {
                    //System.out.println(this.name+": unidentified color!");
                    landType = 'O';//other
                }

		
		return landType;
	}


/* This method returns the zone type for any given coordinates. If the coorinates are out of bounds then color value is returned 0,0,0 which will result in "not available"
if mask is not available, then zone is not queried
*/

        public double[] getSUITarray(double lat, double lon, int res) {
   
double[] suit = {0,0,0,0,0,0,0,0,0};
res = Math.min((int)this.maxEvalRadius, res);

int iMax = (int)(res/this.dlatInMeters);
int jMax = (int)(res/this.dlonInMeters); 

double totalCounter =0;
double urbanCounter =0;
double suburbanCounter =0;
double vegeCounter = 0;
double trafficCounter = 0;
double seaCounter = 0;
double harborCounter=0;
double lakeCounter = 0;
double econoIndCounter=0;



for (int j = -jMax;j<jMax;j++) {
    for (int i = -iMax;i<iMax;i++) {
    double currLon= lon + j*this.dlon;
    double currLat = lat + i*this.dlat;
    char returnedZone ='X';      
    try {
    returnedZone = this.get_maskChar(currLat, currLon);
    //System.out.println("Returned zonetype: "+returnedZone);
                 if(returnedZone=='U') {
                  urbanCounter++;
                  totalCounter++;
              } else if (returnedZone=='S') {
                 suburbanCounter++;
                 totalCounter++;
              } else if (returnedZone=='T') {
                 trafficCounter++;
                 totalCounter++;
              } else if (returnedZone=='H') {
              totalCounter++;
              harborCounter++; 
              } else if (returnedZone=='V') {
                 vegeCounter++;
                 totalCounter++;
              } else if (returnedZone=='W') {
                 seaCounter++;
                 totalCounter++;
                 } else if (returnedZone=='w') {
                 lakeCounter++;
                 totalCounter++;
                 } else if (returnedZone=='I') {
                 econoIndCounter++;
                 totalCounter++;
            }
 
    } catch (Exception e) {
       System.out.println("Could not retrieve zonetype!"); 
    }
 
}
}

if (totalCounter ==0) {
    return suit;
}
//convert to percentages
urbanCounter =(double)(urbanCounter/totalCounter);
suburbanCounter =(double)(suburbanCounter/totalCounter);
vegeCounter = (double)(vegeCounter/totalCounter);
trafficCounter = (double)(trafficCounter/totalCounter);
seaCounter = (double)(seaCounter/totalCounter);
harborCounter=(double)(harborCounter/totalCounter);
lakeCounter = (double)(lakeCounter/totalCounter);
econoIndCounter=(double)(econoIndCounter/totalCounter);

suit[1] = suburbanCounter;
suit[2] = urbanCounter;
suit[3] = econoIndCounter;
suit[4] = trafficCounter;
suit[5] = vegeCounter;
suit[6] = seaCounter + lakeCounter;
suit[7] = totalCounter;

//System.out.println(suit[0] +" "+ suit[1]+" "+ suit[2]+" "+ suit[3]+" " + suit[4]+" " + suit[5]);
return suit; //suit
        }


	public boolean containsCoordinates(double lat1,double lon1) {
            
            if(lat1 >= this.latmax || lat1 <= this.latmin || lon1 >= this.lonmax || lon1 <= this.lonmin ) {
             //   console.out("point 1 is not covered. (lat, lon) " +lat1 +", "+lon1);
                return false;
                
                    } else {           
                    return true;
                    } 
        }

}//Class END





