package services.pescado.fusionservice.impl.database;

import java.util.ArrayList;
import java.util.Calendar;

import services.pescado.fusionservice.impl.Masks.Env;
import services.pescado.fusionservice.impl.fuser.Datetime;

public class EqProfile {
	   
    
	public static int POP_INDEX =0;
	public static int POPxSUB_INDEX =1;
	public static int POPxURB_INDEX =2;
	public static int POPxECOIND_INDEX =3;
	public static int POPxTRAF_INDEX =4;
	//public static int VEGE_INDEX =6;
	//public static int WATER_INDEX =7;
	public static int CONSTANT_INDEX = 5;

	    
	public String type;
	int typeInt;

	private double[][][] allCoeffs;

	/*
	private double[][] monfri_coeffs;
	private double[][] sat_coeffs;
	private double[][] sun_coeffs;

	private double[][] summer_monfri_coeffs;
	private double[][] summer_sat_coeffs;
	private double[][] summer_sun_coeffs;

	 * 
	 */

	//public double correctionStrength;
	boolean allowNegative = false;

	public EqProfile( ArrayList<String[]> data) {
	    this.type = data.get(0)[0];
	    
	    this.typeInt = Options.getTypeInt(type);
	    
	    if (this.typeInt == Options.VAR_TEMP) this.allowNegative = true;
	   
	    /*
	    this.correctionStrength = 1.0;
	    if (this.typeInt == Options.VAR_O3) {
	        this.correctionStrength = 0.7;
	    }
	    
	     * 
	     
	    
	     this.monfri_coeffs = new double[24][7];
	     this.sat_coeffs = new double[24][7];
	     this.sun_coeffs = new double[24][7];
	     this.summer_monfri_coeffs = new double[24][7];
	     this.summer_sat_coeffs = new double[24][7];
	     this.summer_sun_coeffs = new double[24][7];

	     * 
	     */
	                               //[season][hour][coeffIndex]
	    this.allCoeffs = new double[7][24][7];
	     
	    for (int h = 0;h<data.size();h++) {
	        
	        String[] temp = data.get(h);
	        int hour =0;
	        String season = temp[2];
	        int index;
	        
	        //fetch right set
	        if (season.equals("mon_fri")) {
	            index = Options.AVE_INDEX_MOFRI;
	        } else if(season.equals("sat")) {
	            index = Options.AVE_INDEX_SAT;
	        } else if(season.equals("sun")) {
	            index = Options.AVE_INDEX_SUN;
	            
	        } else if(season.equals("summer_mon_fri")) {
	            index = Options.AVE_INDEX_SUMMER_MOFRI;
	        } else if(season.equals("summer_sat")) {
	            index = Options.AVE_INDEX_SUMMER_SAT;
	        
	        } else if(season.equals("summer_sun")) {
	            index = Options.AVE_INDEX_SUMMER_SUN;  
	        
	        } else {
	          index = Options.AVE_INDEX_All;
	        }
	        
	        
	        try {
	        hour = Integer.valueOf(temp[1]);
	        } catch (NumberFormatException e) {
	            System.out.println("Skipping line... bad hour value: "+temp[1]);
	         continue;   
	        }
	        for (int i =3;i<10;i++) {
	            //System.out.print(temp[i] + "\t");
	            this.allCoeffs[index][hour][i-3] = Double.valueOf(temp[i]);
	        }
	        //System.out.println();
	    }
	    
	}



	private int getCorrectSetIndex(Datetime dt) {
	    
	    if (dt.calMonth == Calendar.JUNE || dt.calMonth == Calendar.JULY || dt.calMonth == Calendar.AUGUST || dt.calMonth == Calendar.SEPTEMBER) {
	       if (dt.dayOfWeek == Calendar.SATURDAY) {
	          return Options.AVE_INDEX_SUMMER_SAT;
	       } else if (dt.dayOfWeek == Calendar.SUNDAY) {
	           return Options.AVE_INDEX_SUMMER_SUN;
	       } else {
	           return Options.AVE_INDEX_SUMMER_MOFRI;
	       }
	        
	    } else { // not summer
	        
	        if (dt.dayOfWeek == Calendar.SATURDAY) {
	          return Options.AVE_INDEX_SUMMER_SAT;
	       } else if (dt.dayOfWeek == Calendar.SUNDAY) {
	           return Options.AVE_INDEX_SUMMER_SUN;
	       }else if (dt.dayOfWeek == Calendar.SUNDAY) {
	           return Options.AVE_INDEX_SUMMER_MOFRI;
	       }
	       
	       else {
	           return Options.AVE_INDEX_All;
	       }
	        
	    }
	    
	}


	public double getAverage(Env env, int h, int s) {
	    
	   
	   int hour = h;

	double popCoeff = env.pop;
	if (env.pop<30 && env.traf > 0.1 && (env.urban + env.econoInd) < 0.05 && env.vege > 0.5) popCoeff = 30; // population is a proxy for traffic density and thus it does not work by itself with roads outside cities
	   //y =  -0.037x1+ 0.115x1x2+ 0.02x1x3+ 0.218x1x4+ 0.599x1x5+ 19.421c 
	double reducedTraf = env.traf;
	if (reducedTraf > 0.5) reducedTraf = 0.5; 
	double ave = 
	      popCoeff*this.allCoeffs[s][hour][0] +
	      popCoeff*env.sub*this.allCoeffs[s][hour][1] +
	      popCoeff*env.urban*this.allCoeffs[s][hour][2] +
	      popCoeff*env.econoInd*this.allCoeffs[s][hour][3] +       
	      popCoeff*reducedTraf*this.allCoeffs[s][hour][4] +
	      env.neutral*this.allCoeffs[s][hour][5] + 
	      this.allCoeffs[s][hour][6];    
	return ave;    
	    
	    
	}


	public double getAverage(Env env, Datetime dt) {
	 
	int s = this.getCorrectSetIndex(dt); 
	int hour = dt.hour;

	double popCoeff = env.pop;
	if (env.pop<30 && env.traf > 0.1 && (env.urban + env.econoInd) < 0.05 && env.vege > 0.5) popCoeff = 30; // population is a proxy for traffic density and thus it does not work by itself with roads outside cities
	   //y =  -0.037x1+ 0.115x1x2+ 0.02x1x3+ 0.218x1x4+ 0.599x1x5+ 19.421c 
	double reducedTraf = env.traf;
	if (reducedTraf > 0.5) reducedTraf = 0.5; 
	double ave = 
	      popCoeff*this.allCoeffs[s][hour][0] +
	      popCoeff*env.sub*this.allCoeffs[s][hour][1] +
	      popCoeff*env.urban*this.allCoeffs[s][hour][2] +
	      popCoeff*env.econoInd*this.allCoeffs[s][hour][3] +       
	      popCoeff*reducedTraf*this.allCoeffs[s][hour][4] +
	      env.neutral*this.allCoeffs[s][hour][5] + 
	      this.allCoeffs[s][hour][6];    
	return ave;   
	}

	public double getProfileCorrection(Env tEnv,Env esEnv, Datetime esDt, Datetime tDt) {
	      
	   double esAve = this.getAverage(esEnv, esDt);
	   double tAve = this.getAverage(tEnv, tDt);
	    
	    return tAve - esAve;
	}

}
