package services.pescado.fusionservice.impl.datapack;

import java.util.ArrayList;
import services.pescado.fusionservice.impl.fuser.Datetime;

/**
 * 
 * @author johanssl
 */
public class DataPack {
	public ArrayList<VariableData> variables;
	public Datetime start;
	public Datetime end;
	int size = 0;

	// pescado constructor
	public DataPack(ArrayList<Observation> obs) {
		this.variables = new ArrayList<VariableData>();

		for (int i = 0; i < obs.size(); i++) {
			this.addObservation(obs.get(i));
			this.size++;
		}

		System.out.println("DataPack complete.");
		System.out.println("Number of variables: " + this.variables.size());
		System.out.println("Number of observations: " + this.size);

	}

	// this method adds Observation to the DataPack. If the variable is new, a
	// new Variable data is created
	// Furthermore, if the source is new inside the proper vd, then a new source
	// is created to that vd and Obs is added to it.
	public void addObservation(Observation obs) {
		// check if variable already exists
		boolean isNewVar = true;
		for (int i = 0; i < this.variables.size(); i++) {
			if (variables.get(i).type.equals(obs.type)) {

				variables.get(i).addObservation(obs);// adds new source if
														// needed
				isNewVar = false;
				break;
			}
		}

		if (isNewVar)
			this.variables.add(new VariableData(obs)); // also adds a new source
														// inside the new vd,
														// obviously (each
														// Observation must
														// belong to a source)

	}

	

	public boolean containsVar(String type) {
		for (int i = 0; i < this.variables.size(); i++) {
			if (this.variables.get(i).type.equals(type))
				return true;
		}
		return false;
	}

	public double[] getBoundaries(String type) {
		double latmin = 0;
		double latmax = 0;
		double lonmin = 0;
		double lonmax = 0;

		for (int v = 0; v < this.variables.size(); v++) {
			if (!this.variables.get(v).type.equals(type))
				continue;
			for (int s = 0; s < this.variables.get(v).sources.size(); s++) {

				for (int o = 0; o < this.variables.get(v).sources.get(s).source_obs
						.size(); o++) {
					// Observation obs =
					// this.variables.get(v).sources.get(s).source_obs
					// .get(o);

					// TODO eval boundaries

				}

			}

		}

		double[] returnable = { lonmin, lonmax, latmin, latmax };
		return returnable;
	}

	public VariableData getVarData(String type) {
		// VariableData vd = null;

		for (int i = 0; i < this.variables.size(); i++) {
			if (this.variables.get(i).type.equals(type))
				return this.variables.get(i);
		}

		return null;

	}

}// class end

