package services.pescado.fusionservice.impl.datapack;

import services.pescado.fusionservice.impl.Masks.Env;
import services.pescado.fusionservice.impl.fuser.Datetime;

/**
 * 
 * @author johanssl
 */

public class Observation {

	public final double pi = Math.PI;
	public final double degreeInMeters = 2*pi*6371000/360;
	public	String type;
	public String opDataType;
		//double weight;
	public	String ID;
	public	double latitude, longitude;
	public double d_offset;
        public int t_offset;

                public Datetime datetime;
               public Env env;
                
		public double base_var;
        public double duration; //in hours
		public double value;
	    public boolean model;

	// public boolean dislocalized;

	public Observation(String type, String ID, double latitude, double longitude, Datetime t_taken, double value,double baseVar, boolean model, Env env, double d_offset, int t_offset, String opDataType, double duration ) {
		this.model = model;
		this.latitude = latitude;
		this.longitude = longitude;
	        this.t_offset = t_offset;
	        this.d_offset = d_offset;
	        
	        this.datetime = t_taken;
		this.type=type;
		this.opDataType = opDataType;
		this.ID = ID;
		this.value = value;
		
		if (this.type.equals("CO") || value < 1) {
			value = value*1000;
		}
		
		this.base_var = baseVar;
		this.duration = duration;
	        if (env == null) {
	        double[] temp = null;    
	        this.env = new Env(temp);    
	        } else {
	        this.env = env;    
	        }
	       
	 
	        	
	}

	public long getSecCounter() {
		return (this.datetime.secCounter);
	}

	// This method calculates the distance between the given coordinates and
	// this observation
	public double calc_spatial_distance(double lat, double lon) {

		double distance = 0;
		double scaler = Math.cos(2 * pi * lat / 360);
		distance = Math.sqrt((lat - this.latitude) * (lat - this.latitude)
				+ scaler * scaler * (lon - this.longitude)
				* (lon - this.longitude));

		distance = distance * degreeInMeters; // now the distance is in meters

		return distance;

	}

	// TODO OBSOLETE!
	// This method calculates the temporal difference in SECONDS between the
	// given time and this observation
	public int calc_temporal_distance(Datetime datetime1) {

		long checksum = (this.datetime.secCounter);
		long checksum1 = (datetime1.secCounter);
		return (int) Math.abs(checksum1 - checksum);

	}

}// OBSERVATION END
