package services.pescado.fusionservice.impl.datapack;

/**
 *
 * @author johanssl
 */
import services.pescado.fusionservice.impl.fuser.Datetime;

public class StationarySource extends Source {

	// public ArrayList<Observation> source_obs;
	// public String ID;
	public double latitude, longitude;
	// public double baseSTD;
	// public String profile;
	// public String type;
	// public int amountOfObs;
	public double popDensity = 0.0;

	// Constructor
	public StationarySource(Observation obs) {

		super(obs);
		this.latitude = obs.latitude;
		this.longitude = obs.longitude;

	}

	// This method presumes that each source has fixed coordinates and therefore
	// fixed zone. The only variable is then the time
	// This method returns the observation which is timewise the closest.
	@Override
	public Observation get_best_obs(Datetime ens_datetime, double lat,
			double lon, boolean smooth) {

		int t_nearest = Integer.MAX_VALUE; // sec
		int index = Integer.MAX_VALUE;
		for (int i = 0; i < this.source_obs.size(); i++) {

			int t_diff = this.source_obs.get(i).calc_temporal_distance(
					ens_datetime);

			if (t_diff < t_nearest) {
				t_nearest = t_diff;
				index = i;
			}

		}

		return this.source_obs.get(index);
	}

	@Override
	public double getLat() {
		return this.latitude;
	}

	@Override
	public double getLon() {
		return this.longitude;
	}

}// Class end bracket
