package services.pescado.fusionservice.impl.fuser;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;


/**
 * 
 * @author johanssl
 */

public class Datetime
{
	
	public static String FORMAT1 = "yyyy-MM-dd'T'HH:mm:ss'+'SS";
	public static String FORMAT1ex = "2010-05-30T23:59:59+01:00";
	public static String FORMAT2 = "yyyy-MM-dd'T'HH:mm:ss'-'SS";
	public static String FORMAT2ex = "2010-05-30T23:59:59-01:00";
	
	public static String FORMAT3 = "yyyy-MM-dd'T'HH:mm:ss'.000+'SS";
	public static String FORMAT3ex = "2010-05-30T23:59:59.000+01:00";
	
	public static String FORMAT4 = "yyyy-MM-dd'T'HH:mm:ss'.000-'SS";
	public static String FORMAT4ex = "2010-05-30T23:59:59.000-01:00";
	
	public static String FORMAT5 = "yyyy-MM-dd'T'HH:mm:ss";
	public static String FORMAT5ex = "2010-05-30T23:59:59";
	
	public static String FORMAT6ex = "2010-05-30T23:59:59.00";
	public static String FORMAT7ex = "2010-05-30T23:59:59.000";
	
	
	
	public int usedFormat =0;
	public int	year;
	public int dayOfWeek;
	public int month;
	public int calMonth;
	public int	day;
	public int	hour;
	public int	min;
	public int	sec;
	public long	secCounter;
	public long	hourCounter;	// hours

	Calendar		cal;
	Date				date;
	public int	timeZone;


	public Datetime (String timestamp)
	{
		boolean hasZone = true;
		boolean posZone = true;
		this.min = 0;
		this.sec = 0;
		this.timeZone = 0;
		this.cal = Calendar.getInstance ();
		
		SimpleDateFormat formatter = new SimpleDateFormat (// basic pattern with
				
				Datetime.FORMAT1);
		formatter.setLenient (false);
		try
		{
			this.date = formatter.parse (timestamp);
			hasZone = true;
			posZone = true;// negative timezone
			this.usedFormat =1;
		}
		catch (ParseException ex)
		{// basic pattern with negative timezone
			formatter = new SimpleDateFormat (Datetime.FORMAT2);
			formatter.setLenient (false);
			
			try
			{
				this.date = formatter.parse (timestamp);
				hasZone = true;
				posZone = false;// negative timezone
				this.usedFormat =2;
			}
			catch (ParseException ex1)
			{// pattern with positive timezone and

				formatter = new SimpleDateFormat (Datetime.FORMAT3);
				formatter.setLenient (false);
				try
				{
					this.date = formatter.parse (timestamp);
					hasZone = true;
					posZone = true;// negative timezone
					this.usedFormat = 3;
				}
				catch (ParseException ex2)
				{
					formatter = new SimpleDateFormat (Datetime.FORMAT4);
					
					formatter.setLenient (false);
					try
					{
						this.date = formatter.parse (timestamp);
						hasZone = true;
						posZone = false;// negative timezone
						this.usedFormat = 4;
					}
					catch (ParseException ex3)
					{
						//DATES WITHOUT ZONE============
						formatter = new SimpleDateFormat (Datetime.FORMAT5);
						formatter.setLenient (false);
						try
						{	
					
							this.date = formatter.parse (timestamp);
							hasZone = false;
							this.usedFormat = 5;
						}
						catch (ParseException ex4)
						{
							// Logger.getLogger(Datetime.class.getName()).log(Level.SEVERE,
							// null, ex2);
							System.err.println ("Could not parse timestmap: " + timestamp);
						}// parse 5th
					} // parse 4th
				}// parse 3rd
			}// parse 2nd
		}// parse 1st

		cal = GregorianCalendar.getInstance (); // creates a new calendar
		// instance
		cal.setTime (date); // assigns calendar to given date
		this.year = cal.get (Calendar.YEAR);
		this.month = cal.get (Calendar.MONTH) + 1;
		this.calMonth = cal.get(Calendar.MONTH); 
        this.day = cal.get(Calendar.DAY_OF_MONTH);
        this.hour = cal.get(Calendar.HOUR_OF_DAY);
        this.dayOfWeek = cal.get(Calendar.DAY_OF_WEEK);
		
		if (hasZone) {
			this.timeZone = cal.get (Calendar.MILLISECOND);// we need to use the millisecond slot for timezone
		} else {
			this.timeZone = 0; // UTC-0
		}

		if (!posZone)
			this.timeZone = this.timeZone * -1; 
		try
		{
			this.min = cal.get (Calendar.MINUTE);
			this.sec = cal.get (Calendar.SECOND);
		}
		catch (Exception e)
		{
			e.printStackTrace ();
		}
		this.secCounter = (cal.getTimeInMillis () / 1000) - this.timeZone * 3600;
		this.hourCounter = this.secCounter / 3600;// hourCounter

	}

    
	public void addSeconds (int seconds)
	{
		this.cal.add (Calendar.SECOND, seconds);
		this.refreshFields ();
	}


	public void refreshFields ()
	{
		this.year = cal.get (Calendar.YEAR);
		this.month = cal.get (Calendar.MONTH) + 1;
		this.day = cal.get (Calendar.DAY_OF_MONTH);
		this.hour = cal.get (Calendar.HOUR_OF_DAY);
		this.min = cal.get (Calendar.MINUTE);
		this.sec = cal.get (Calendar.SECOND);
		this.secCounter = (cal.getTimeInMillis () / 1000) - this.timeZone * 3600;
		this.hourCounter = this.secCounter / 3600;
	}


	// this method returns datetime to its original string form (the primary
	// formatter form)
	public String getStringDate ()
	{

		String smonth;
		if (this.month < 10)
		{
			smonth = "0" + this.month;
		}
		else
		{
			smonth = String.valueOf (this.month);
		}
		String sday;
		if (this.day < 10)
		{
			sday = "0" + this.day;
		}
		else
		{
			sday = String.valueOf (this.day);
		}

		String shour;
		if (this.hour < 10)
		{
			shour = "0" + this.hour;
		}
		else
		{
			shour = String.valueOf (this.hour);
		}

		String smin;
		if (this.min < 10)
		{
			smin = "0" + this.min;
		}
		else
		{
			smin = String.valueOf (this.min);
		}

		String ssec;
		if (this.sec < 10)
		{
			ssec = "0" + this.sec;
		}
		else
		{
			ssec = String.valueOf (this.sec);
		}

		String zone = "";
		String O = "0";
		if (this.timeZone > 9 || this.timeZone < -9)
			O = "";// no zero needed
		if (this.timeZone < 0)
		{
			zone = "-" + O + this.timeZone * -1 + ":00";
		}
		else
		{
			zone = "+" + O + this.timeZone + ":00";
		}

		String temp = this.year + "-" + smonth + "-" + sday + "T" + shour + ":" + smin + ":" + ssec + zone;

		return temp;
	}


	public void convertToGMT (int newGMT)
	{
		int currentZone = this.timeZone;
		// for instance: old zone = -2:00 and we wish to have +2:00
		// then separation is 4 and time is increased by 4 hours and GMT is set to
		// 2:00
		int separation = newGMT - currentZone;
		this.timeZone = newGMT;
		this.addSeconds (separation * 3600);

	}
	
	public static void testFormats() {
		
		Datetime dt = new Datetime(Datetime.FORMAT1ex);
		System.out.println("trying "+Datetime.FORMAT1ex);
		System.out.println(dt.getStringDate() + "\t parsing = " + dt.usedFormat);
		
		dt = new Datetime(Datetime.FORMAT2ex);
		System.out.println("trying "+Datetime.FORMAT2ex);
		System.out.println(dt.getStringDate() + "\t parsing = " + dt.usedFormat);
		
		dt = new Datetime(Datetime.FORMAT3ex);
		System.out.println("trying "+Datetime.FORMAT3ex);
		System.out.println(dt.getStringDate() + "\t parsing = " + dt.usedFormat);
		
		dt = new Datetime(Datetime.FORMAT4ex);
		System.out.println("trying "+Datetime.FORMAT4ex);
		System.out.println(dt.getStringDate() + "\t parsing = " + dt.usedFormat);
		
		dt = new Datetime(Datetime.FORMAT5ex);
		System.out.println("trying "+Datetime.FORMAT5ex);
		System.out.println(dt.getStringDate() + "\t parsing = " + dt.usedFormat);
		
		dt = new Datetime(Datetime.FORMAT6ex);
		System.out.println("trying "+Datetime.FORMAT6ex);
		System.out.println(dt.getStringDate() + "\t parsing = " + dt.usedFormat);
		
		dt = new Datetime(Datetime.FORMAT7ex);
		System.out.println("trying "+Datetime.FORMAT7ex);
		System.out.println(dt.getStringDate() + "\t parsing = " + dt.usedFormat);
		
		
		
	}

}// class end

