/**
 * The general task of the FS is to process the data received from different environmental service nodes via the Data Retrieval Service with the purpose to obtain the best and most complete data set to address the users request for information or decision support. It thus
 * (i) identifies complementary pieces of data proceeding from different data sources of the same kind (i.e., AQ, meteorology, traffic, etc.) and fuses them into one coherent data block;
 * (ii) identifies alternative (or competing) pieces of data proceeding from different data sources, but concerning the same environmental phenomenon for the same location, assesses the quality of each of them using the two types of uncertainty metrics developed in PESCaDO (imprecision and confidence metrics), and selects the best for communication to the user.
 * 
 */
@javax.xml.bind.annotation.XmlSchema(namespace = "http://pescado.services/FusionService/")
package services.pescado.fusionservice;
