
package services.pescado.intersectionservice;

import java.net.URL;
import javax.xml.namespace.QName;
import javax.xml.ws.Service;
import javax.xml.ws.WebEndpoint;
import javax.xml.ws.WebServiceClient;
import javax.xml.ws.WebServiceException;
import javax.xml.ws.WebServiceFeature;


/**
 * The Intersection Service segments the area of interest into different parts based on the existing environmental node measurements. It takes as input:
 * Different overlapping geographical areas for measured aspects. This information is provided by the Data Retrieval Service.
 * The service processes this information in order to output non-overlapping geographical areas for the aspects of interest. In every segmented area, different measurements may be reported for the same aspect. These values are fused at a later stage by the Fusion Service.
 * 
 * This class was generated by the JAX-WS RI.
 * JAX-WS RI 2.2.5-b01 
 * Generated source version: 2.2
 * 
 */
@WebServiceClient(name = "IntersectionService", targetNamespace = "http://pescado.services/IntersectionService/", wsdlLocation = "IntersectionService.wsdl")
public class IntersectionService_Service
    extends Service
{

    private final static URL INTERSECTIONSERVICE_WSDL_LOCATION;
    private final static WebServiceException INTERSECTIONSERVICE_EXCEPTION;
    private final static QName INTERSECTIONSERVICE_QNAME = new QName("http://pescado.services/IntersectionService/", "IntersectionService");

    static {
        INTERSECTIONSERVICE_WSDL_LOCATION = services.pescado.intersectionservice.IntersectionService_Service.class.getResource("IntersectionService.wsdl");
        WebServiceException e = null;
        if (INTERSECTIONSERVICE_WSDL_LOCATION == null) {
            e = new WebServiceException("Cannot find 'IntersectionService.wsdl' wsdl. Place the resource correctly in the classpath.");
        }
        INTERSECTIONSERVICE_EXCEPTION = e;
    }

    public IntersectionService_Service() {
        super(__getWsdlLocation(), INTERSECTIONSERVICE_QNAME);
    }

    public IntersectionService_Service(WebServiceFeature... features) {
        super(__getWsdlLocation(), INTERSECTIONSERVICE_QNAME, features);
    }

    public IntersectionService_Service(URL wsdlLocation) {
        super(wsdlLocation, INTERSECTIONSERVICE_QNAME);
    }

    public IntersectionService_Service(URL wsdlLocation, WebServiceFeature... features) {
        super(wsdlLocation, INTERSECTIONSERVICE_QNAME, features);
    }

    public IntersectionService_Service(URL wsdlLocation, QName serviceName) {
        super(wsdlLocation, serviceName);
    }

    public IntersectionService_Service(URL wsdlLocation, QName serviceName, WebServiceFeature... features) {
        super(wsdlLocation, serviceName, features);
    }

    /**
     * 
     * @return
     *     returns IntersectionService
     */
    @WebEndpoint(name = "IntersectionServiceSOAP")
    public IntersectionService getIntersectionServiceSOAP() {
        return super.getPort(new QName("http://pescado.services/IntersectionService/", "IntersectionServiceSOAP"), IntersectionService.class);
    }

    /**
     * 
     * @param features
     *     A list of {@link javax.xml.ws.WebServiceFeature} to configure on the proxy.  Supported features not in the <code>features</code> parameter will have their default values.
     * @return
     *     returns IntersectionService
     */
    @WebEndpoint(name = "IntersectionServiceSOAP")
    public IntersectionService getIntersectionServiceSOAP(WebServiceFeature... features) {
        return super.getPort(new QName("http://pescado.services/IntersectionService/", "IntersectionServiceSOAP"), IntersectionService.class, features);
    }

    private static URL __getWsdlLocation() {
        if (INTERSECTIONSERVICE_EXCEPTION!= null) {
            throw INTERSECTIONSERVICE_EXCEPTION;
        }
        return INTERSECTIONSERVICE_WSDL_LOCATION;
    }

}
