
package services.pescado.knowledgebaseaccessservice;

import java.util.List;
import javax.activation.DataHandler;
import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebResult;
import javax.jws.WebService;
import javax.jws.soap.SOAPBinding;
import javax.xml.bind.annotation.XmlSeeAlso;
import javax.xml.ws.RequestWrapper;
import javax.xml.ws.ResponseWrapper;


/**
 * This class was generated by the JAX-WS RI.
 * JAX-WS RI 2.2.5-b01 
 * Generated source version: 2.2
 * 
 */
@WebService(name = "KnowledgeBaseAccessService", targetNamespace = "http://pescado.services/KnowledgeBaseAccessService/")
@XmlSeeAlso({
    opengis.net.ows.ex.ObjectFactory.class,
    org.w3._2005._05.xmlmime.ObjectFactory.class,
    services.pescado.common.ObjectFactory.class,
    services.pescado.knowledgebaseaccessservice.ObjectFactory.class
})
public interface KnowledgeBaseAccessService {


    /**
     * Informs the client about the common and specific capabilities of a Knowledge Base Access Service instance. Examples of specific capabilities are:
     * - The names of the ontology modules available in the Knowledge Base.
     * - The possible representation formats of query results which can be requested by clients.
     * - The query languages that can be used in knowledge base queries.
     * - The inference capabilities of the knowledge base applied when computing query results.
     * 
     * @param in
     * @return
     *     returns java.lang.String
     */
    @WebMethod(action = "http://pescado.services/KnowledgeBaseAccessService/getCapabilities")
    @WebResult(name = "out", targetNamespace = "")
    @RequestWrapper(localName = "getCapabilities", targetNamespace = "http://pescado.services/KnowledgeBaseAccessService/", className = "services.pescado.knowledgebaseaccessservice.GetCapabilities")
    @ResponseWrapper(localName = "getCapabilitiesResponse", targetNamespace = "http://pescado.services/KnowledgeBaseAccessService/", className = "services.pescado.knowledgebaseaccessservice.GetCapabilitiesResponse")
    public String getCapabilities(
        @WebParam(name = "in", targetNamespace = "")
        String in);

    /**
     * Stores a new ontology module in the Knowledge Base.
     * 
     * @param ontology
     * @return
     *     returns java.lang.String
     */
    @WebMethod(action = "http://pescado.services/KnowledgeBaseAccessService/setOntology")
    @WebResult(name = "ontologyIdentifier", targetNamespace = "")
    @RequestWrapper(localName = "setOntology", targetNamespace = "http://pescado.services/KnowledgeBaseAccessService/", className = "services.pescado.knowledgebaseaccessservice.SetOntology")
    @ResponseWrapper(localName = "setOntologyResponse", targetNamespace = "http://pescado.services/KnowledgeBaseAccessService/", className = "services.pescado.knowledgebaseaccessservice.SetOntologyResponse")
    public String setOntology(
        @WebParam(name = "ontology", targetNamespace = "")
        String ontology);

    /**
     * Retrieves an existing ontology module or a selection of an ontology module from the Knowledge Base.
     * 
     * @param ontologyIdentifier
     * @return
     *     returns java.lang.String
     */
    @WebMethod(action = "http://pescado.services/KnowledgeBaseAccessService/getOntology")
    @WebResult(name = "owl", targetNamespace = "")
    @RequestWrapper(localName = "getOntology", targetNamespace = "http://pescado.services/KnowledgeBaseAccessService/", className = "services.pescado.knowledgebaseaccessservice.GetOntology")
    @ResponseWrapper(localName = "getOntologyResponse", targetNamespace = "http://pescado.services/KnowledgeBaseAccessService/", className = "services.pescado.knowledgebaseaccessservice.GetOntologyResponse")
    public String getOntology(
        @WebParam(name = "ontologyIdentifier", targetNamespace = "")
        String ontologyIdentifier);

    /**
     * Removes an existing ontology module from the Knowledge Base.
     * 
     * @param ontologyIdentifier
     * @return
     *     returns java.lang.String
     */
    @WebMethod(action = "http://pescado.services/KnowledgeBaseAccessService/deleteOntology")
    @WebResult(name = "out", targetNamespace = "")
    @RequestWrapper(localName = "deleteOntology", targetNamespace = "http://pescado.services/KnowledgeBaseAccessService/", className = "services.pescado.knowledgebaseaccessservice.DeleteOntology")
    @ResponseWrapper(localName = "deleteOntologyResponse", targetNamespace = "http://pescado.services/KnowledgeBaseAccessService/", className = "services.pescado.knowledgebaseaccessservice.DeleteOntologyResponse")
    public String deleteOntology(
        @WebParam(name = "ontologyIdentifier", targetNamespace = "")
        String ontologyIdentifier);

    /**
     * Given an ontology or a part (segment) of an ontology, returns a list of TBox statements ready to be used for creating a Knowledge Base.
     * 
     * @param ontologyIdentifier
     * @return
     *     returns java.lang.String
     */
    @WebMethod(action = "http://pescado.services/KnowledgeBaseAccessService/getTBoxVocabulary")
    @WebResult(name = "out", targetNamespace = "")
    @RequestWrapper(localName = "getTBoxVocabulary", targetNamespace = "http://pescado.services/KnowledgeBaseAccessService/", className = "services.pescado.knowledgebaseaccessservice.GetTBoxVocabulary")
    @ResponseWrapper(localName = "getTBoxVocabularyResponse", targetNamespace = "http://pescado.services/KnowledgeBaseAccessService/", className = "services.pescado.knowledgebaseaccessservice.GetTBoxVocabularyResponse")
    public String getTBoxVocabulary(
        @WebParam(name = "ontologyIdentifier", targetNamespace = "")
        String ontologyIdentifier);

    /**
     * Given an ontology or a part (segment) of an ontology, returns a list of ABox statements ready to be used for creating a Knowledge Base.
     * 
     * @param ontologyIdentifier
     * @return
     *     returns java.lang.String
     */
    @WebMethod(action = "http://pescado.services/KnowledgeBaseAccessService/getABoxVocabulary")
    @WebResult(name = "out", targetNamespace = "")
    @RequestWrapper(localName = "getABoxVocabulary", targetNamespace = "http://pescado.services/KnowledgeBaseAccessService/", className = "services.pescado.knowledgebaseaccessservice.GetABoxVocabulary")
    @ResponseWrapper(localName = "getABoxVocabularyResponse", targetNamespace = "http://pescado.services/KnowledgeBaseAccessService/", className = "services.pescado.knowledgebaseaccessservice.GetABoxVocabularyResponse")
    public String getABoxVocabulary(
        @WebParam(name = "ontologyIdentifier", targetNamespace = "")
        String ontologyIdentifier);

    /**
     * This function allows for inserting a triple into the knowledge base.
     * 
     * @param subject
     * @param ontologyIdentifier
     * @param predicate
     * @param object
     * @return
     *     returns java.lang.String
     */
    @WebMethod(action = "http://pescado.services/KnowledgeBaseAccessService/addABoxStatement")
    @WebResult(name = "out", targetNamespace = "")
    @RequestWrapper(localName = "addABoxStatement", targetNamespace = "http://pescado.services/KnowledgeBaseAccessService/", className = "services.pescado.knowledgebaseaccessservice.AddABoxStatement")
    @ResponseWrapper(localName = "addABoxStatementResponse", targetNamespace = "http://pescado.services/KnowledgeBaseAccessService/", className = "services.pescado.knowledgebaseaccessservice.AddABoxStatementResponse")
    public String addABoxStatement(
        @WebParam(name = "ontologyIdentifier", targetNamespace = "")
        String ontologyIdentifier,
        @WebParam(name = "subject", targetNamespace = "")
        String subject,
        @WebParam(name = "predicate", targetNamespace = "")
        String predicate,
        @WebParam(name = "object", targetNamespace = "")
        String object);

    /**
     * This function allows for inserting n triples into the knowledge base.
     * 
     * @param ontologyIdentifier
     * @param statements
     * @return
     *     returns java.lang.String
     */
    @WebMethod(action = "http://pescado.services/KnowledgeBaseAccessService/addABoxStatements")
    @WebResult(name = "out", targetNamespace = "")
    @RequestWrapper(localName = "addABoxStatements", targetNamespace = "http://pescado.services/KnowledgeBaseAccessService/", className = "services.pescado.knowledgebaseaccessservice.AddABoxStatements")
    @ResponseWrapper(localName = "addABoxStatementResponse", targetNamespace = "http://pescado.services/KnowledgeBaseAccessService/", className = "services.pescado.knowledgebaseaccessservice.AddABoxStatementResponse")
    public String addABoxStatements(
        @WebParam(name = "ontologyIdentifier", targetNamespace = "")
        String ontologyIdentifier,
        @WebParam(name = "statements", targetNamespace = "")
        List<StatementType> statements);

    /**
     * This function allows for removing a triple from the knowledge base.
     * 
     * @param subject
     * @param ontologyIdentifier
     * @param predicate
     * @param object
     * @return
     *     returns java.lang.String
     */
    @WebMethod(action = "http://pescado.services/KnowledgeBaseAccessService/removeABoxStatement")
    @WebResult(name = "out", targetNamespace = "")
    @RequestWrapper(localName = "removeABoxStatement", targetNamespace = "http://pescado.services/KnowledgeBaseAccessService/", className = "services.pescado.knowledgebaseaccessservice.RemoveABoxStatement")
    @ResponseWrapper(localName = "removeABoxStatementResponse", targetNamespace = "http://pescado.services/KnowledgeBaseAccessService/", className = "services.pescado.knowledgebaseaccessservice.RemoveABoxStatementResponse")
    public String removeABoxStatement(
        @WebParam(name = "ontologyIdentifier", targetNamespace = "")
        String ontologyIdentifier,
        @WebParam(name = "subject", targetNamespace = "")
        String subject,
        @WebParam(name = "predicate", targetNamespace = "")
        String predicate,
        @WebParam(name = "object", targetNamespace = "")
        String object);

    /**
     * Returns a list of concepts of an ontology (module) or a part (segment) of an ontology (module).
     * 
     * @param ontologyIdentifier
     * @return
     *     returns java.lang.String
     */
    @WebMethod(action = "http://pescado.services/KnowledgeBaseAccessService/getListConcepts")
    @WebResult(name = "out", targetNamespace = "")
    @RequestWrapper(localName = "getListConcepts", targetNamespace = "http://pescado.services/KnowledgeBaseAccessService/", className = "services.pescado.knowledgebaseaccessservice.GetListConcepts")
    @ResponseWrapper(localName = "getListConceptsResponse", targetNamespace = "http://pescado.services/KnowledgeBaseAccessService/", className = "services.pescado.knowledgebaseaccessservice.GetListConceptsResponse")
    public String getListConcepts(
        @WebParam(name = "ontologyIdentifier", targetNamespace = "")
        String ontologyIdentifier);

    /**
     * Submits a query to the ontologies stored in the knowledge base. The query has to be formulated in a query language (e.g. SPARQL) compatible with the knowledge representation model used by the knowledge base (e.g. RDF/OWL).
     * 
     * @param parameters
     * @return
     *     returns javax.activation.DataHandler
     */
    @WebMethod(action = "http://pescado.services/KnowledgeBaseAccessService/queryOntology")
    @WebResult(name = "queryOntologyResponse", targetNamespace = "http://pescado.services/KnowledgeBaseAccessService/", partName = "parameters")
    @SOAPBinding(parameterStyle = SOAPBinding.ParameterStyle.BARE)
    public DataHandler queryOntology(
        @WebParam(name = "queryOntology", targetNamespace = "http://pescado.services/KnowledgeBaseAccessService/", partName = "parameters")
        QueryOntology parameters);

    /**
     * Dumps some debug information on the server.
     * 
     * @param ontologyIdentifier
     * @param filename
     * @return
     *     returns java.lang.String
     */
    @WebMethod(action = "http://pescado.services/KnowledgeBaseAccessService/dumpDebugInfo")
    @WebResult(name = "out", targetNamespace = "")
    @RequestWrapper(localName = "dumpDebugInfo", targetNamespace = "http://pescado.services/KnowledgeBaseAccessService/", className = "services.pescado.knowledgebaseaccessservice.DumpDebugInfo")
    @ResponseWrapper(localName = "dumpDebugInfoResponse", targetNamespace = "http://pescado.services/KnowledgeBaseAccessService/", className = "services.pescado.knowledgebaseaccessservice.DumpDebugInfoResponse")
    public String dumpDebugInfo(
        @WebParam(name = "ontologyIdentifier", targetNamespace = "")
        String ontologyIdentifier,
        @WebParam(name = "filename", targetNamespace = "")
        String filename);

    /**
     * Resets all changes of the ontology since the last call.
     * 
     * @param ontologyIdentifier
     * @param in
     * @return
     *     returns java.lang.String
     */
    @WebMethod(action = "http://pescado.services/KnowledgeBaseAccessService/resetOntology")
    @WebResult(name = "out", targetNamespace = "")
    @RequestWrapper(localName = "resetOntology", targetNamespace = "http://pescado.services/KnowledgeBaseAccessService/", className = "services.pescado.knowledgebaseaccessservice.ResetOntology")
    @ResponseWrapper(localName = "resetOntologyResponse", targetNamespace = "http://pescado.services/KnowledgeBaseAccessService/", className = "services.pescado.knowledgebaseaccessservice.ResetOntologyResponse")
    public String resetOntology(
        @WebParam(name = "ontologyIdentifier", targetNamespace = "")
        String ontologyIdentifier,
        @WebParam(name = "in", targetNamespace = "")
        String in);

    /**
     * This function applies all rules from the given rulesetfile to the selected ontology. The ruleMode property of the RuleReasoner has to be set via the third argument.
     * 
     * @param ruleMode
     * @param rulesetfile
     * @param ontologyIdentifier
     * @param defaultNamespace
     * @return
     *     returns java.lang.String
     */
    @WebMethod(action = "http://pescado.services/KnowledgeBaseAccessService/applyRules")
    @WebResult(name = "out", targetNamespace = "")
    @RequestWrapper(localName = "applyRules", targetNamespace = "http://pescado.services/KnowledgeBaseAccessService/", className = "services.pescado.knowledgebaseaccessservice.ApplyRules")
    @ResponseWrapper(localName = "applyRulesResponse", targetNamespace = "http://pescado.services/KnowledgeBaseAccessService/", className = "services.pescado.knowledgebaseaccessservice.ApplyRulesResponse")
    public String applyRules(
        @WebParam(name = "ontologyIdentifier", targetNamespace = "")
        String ontologyIdentifier,
        @WebParam(name = "rulesetfile", targetNamespace = "")
        String rulesetfile,
        @WebParam(name = "ruleMode", targetNamespace = "")
        String ruleMode,
        @WebParam(name = "defaultNamespace", targetNamespace = "")
        String defaultNamespace);

    /**
     * This function lists all subclasses of the given object which are allowed for the given property and subject.
     * 
     * @param ontologyIdentifier
     * @param property
     * @param objectclass
     * @param subjectclass
     * @return
     *     returns java.util.List<java.lang.String>
     */
    @WebMethod(action = "http://pescado.services/KnowledgeBaseAccessService/getRestrictionsFor")
    @WebResult(name = "out", targetNamespace = "")
    @RequestWrapper(localName = "getRestrictionsFor", targetNamespace = "http://pescado.services/KnowledgeBaseAccessService/", className = "services.pescado.knowledgebaseaccessservice.GetRestrictionsFor")
    @ResponseWrapper(localName = "getRestrictionsForResponse", targetNamespace = "http://pescado.services/KnowledgeBaseAccessService/", className = "services.pescado.knowledgebaseaccessservice.GetRestrictionsForResponse")
    public List<String> getRestrictionsFor(
        @WebParam(name = "ontologyIdentifier", targetNamespace = "")
        String ontologyIdentifier,
        @WebParam(name = "property", targetNamespace = "")
        String property,
        @WebParam(name = "subjectclass", targetNamespace = "")
        String subjectclass,
        @WebParam(name = "objectclass", targetNamespace = "")
        String objectclass);

}
