
package services.pescado.relatedaspectscomputationservice;

import java.net.URL;
import javax.xml.namespace.QName;
import javax.xml.ws.Service;
import javax.xml.ws.WebEndpoint;
import javax.xml.ws.WebServiceClient;
import javax.xml.ws.WebServiceException;
import javax.xml.ws.WebServiceFeature;


/**
 * The Related Aspects Computation Service (RACS) is a service that, given the problem description generated for the request made by the user, selects the aspects that need to be considered for delivering an informative answer to the user.
 * The input of the service is planned to be an action specification (e.g. 'travel from X to Y') and the query focus (or topic, e.g. health issues) submitted by the user, as encoded in the PDL (Problem Description Language) format by the Problem Description Generation Service. The output is a set of focus-related aspects that have to be considered before an answer to the user query is given.
 * Given the action and focus of the user query, the service accesses the Knowledge Base containing general information about aspects relevant to an <action, focus> couple. The Knowledge Base returns a list of relevant aspects, with a possibly empty list of specific constraints that need to be verified to assess the relevance of an aspect for a specific user associated with each of the aspects in question. The RACS will filter the list of aspects returned by the Knowledge Base by matching the constraints associated with each aspect against the information contained in the user profile.
 * 
 * This class was generated by the JAX-WS RI.
 * JAX-WS RI 2.2.5-b01 
 * Generated source version: 2.2
 * 
 */
@WebServiceClient(name = "RelatedAspectsComputationService", targetNamespace = "http://pescado.services/RelatedAspectsComputationService/", wsdlLocation = "RelatedAspectsComputationService.wsdl")
public class RelatedAspectsComputationService_Service
    extends Service
{

    private final static URL RELATEDASPECTSCOMPUTATIONSERVICE_WSDL_LOCATION;
    private final static WebServiceException RELATEDASPECTSCOMPUTATIONSERVICE_EXCEPTION;
    private final static QName RELATEDASPECTSCOMPUTATIONSERVICE_QNAME = new QName("http://pescado.services/RelatedAspectsComputationService/", "RelatedAspectsComputationService");

    static {
        RELATEDASPECTSCOMPUTATIONSERVICE_WSDL_LOCATION = services.pescado.relatedaspectscomputationservice.RelatedAspectsComputationService_Service.class.getResource("RelatedAspectsComputationService.wsdl");
        WebServiceException e = null;
        if (RELATEDASPECTSCOMPUTATIONSERVICE_WSDL_LOCATION == null) {
            e = new WebServiceException("Cannot find 'RelatedAspectsComputationService.wsdl' wsdl. Place the resource correctly in the classpath.");
        }
        RELATEDASPECTSCOMPUTATIONSERVICE_EXCEPTION = e;
    }

    public RelatedAspectsComputationService_Service() {
        super(__getWsdlLocation(), RELATEDASPECTSCOMPUTATIONSERVICE_QNAME);
    }

    public RelatedAspectsComputationService_Service(WebServiceFeature... features) {
        super(__getWsdlLocation(), RELATEDASPECTSCOMPUTATIONSERVICE_QNAME, features);
    }

    public RelatedAspectsComputationService_Service(URL wsdlLocation) {
        super(wsdlLocation, RELATEDASPECTSCOMPUTATIONSERVICE_QNAME);
    }

    public RelatedAspectsComputationService_Service(URL wsdlLocation, WebServiceFeature... features) {
        super(wsdlLocation, RELATEDASPECTSCOMPUTATIONSERVICE_QNAME, features);
    }

    public RelatedAspectsComputationService_Service(URL wsdlLocation, QName serviceName) {
        super(wsdlLocation, serviceName);
    }

    public RelatedAspectsComputationService_Service(URL wsdlLocation, QName serviceName, WebServiceFeature... features) {
        super(wsdlLocation, serviceName, features);
    }

    /**
     * 
     * @return
     *     returns RelatedAspectsComputationService
     */
    @WebEndpoint(name = "RelatedAspectsComputationServiceSOAP")
    public RelatedAspectsComputationService getRelatedAspectsComputationServiceSOAP() {
        return super.getPort(new QName("http://pescado.services/RelatedAspectsComputationService/", "RelatedAspectsComputationServiceSOAP"), RelatedAspectsComputationService.class);
    }

    /**
     * 
     * @param features
     *     A list of {@link javax.xml.ws.WebServiceFeature} to configure on the proxy.  Supported features not in the <code>features</code> parameter will have their default values.
     * @return
     *     returns RelatedAspectsComputationService
     */
    @WebEndpoint(name = "RelatedAspectsComputationServiceSOAP")
    public RelatedAspectsComputationService getRelatedAspectsComputationServiceSOAP(WebServiceFeature... features) {
        return super.getPort(new QName("http://pescado.services/RelatedAspectsComputationService/", "RelatedAspectsComputationServiceSOAP"), RelatedAspectsComputationService.class, features);
    }

    private static URL __getWsdlLocation() {
        if (RELATEDASPECTSCOMPUTATIONSERVICE_EXCEPTION!= null) {
            throw RELATEDASPECTSCOMPUTATIONSERVICE_EXCEPTION;
        }
        return RELATEDASPECTSCOMPUTATIONSERVICE_WSDL_LOCATION;
    }

}
